// myapp_rt.cpp : Using dynamic loading example
//

#include "stdafx.h"
#include <windows.h>
#include <assert.h>

// function pointer
typedef BOOL (*pfn_makeBeep)(DWORD, DWORD);


int _tmain(int argc, _TCHAR* argv[])
{
    _tprintf(_T("[%d]  Process Started\n"), GetCurrentProcessId());

    // Loads the specified module into the address space of the process
	HMODULE hModule = LoadLibrary(_T("mydll"));
	assert(hModule != NULL);

    // Get a pointer to the desired function
	pfn_makeBeep pfnMakeBeep = (pfn_makeBeep)GetProcAddress(hModule, "MakeBeep");
	assert(pfnMakeBeep);

    // Call the function
    for (int i = 0; i < 5; ++i) {
	    pfnMakeBeep(1000, 2000);
        Sleep(1000);
    }

    // Unload the DLL
	FreeLibrary(hModule);

	return 0;
}



