// mydll.cpp : A simple dll example
//   Defines both DLL entry point and exported function


#include "stdafx.h"
#include <windows.h>
#include <tchar.h>


// Entry point for the DLL
BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
    // current process id
    DWORD dwProcessId = GetCurrentProcessId();

    // implement a specific action based on the event that triggered the call
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
        _tprintf(_T("[%d]  DLL_PROCESS_ATTACH\n"), dwProcessId);
        break;
	case DLL_THREAD_ATTACH:
        _tprintf(_T("[%d]  DLL_THREAD_ATTACH\n"), dwProcessId);
        break;
	case DLL_THREAD_DETACH:
        _tprintf(_T("[%d]  DLL_THREAD_DETACH\n"), dwProcessId);
        break;
	case DLL_PROCESS_DETACH:
        _tprintf(_T("[%d]  DLL_PROCESS_DETACH\n"), dwProcessId);
        break;
	}
	return TRUE;
}


// Allow usage in C++ programs
extern "C"
{

// A simple function that makes a beep sound
// This is the function we export from the DLL
__declspec(dllexport) BOOL __cdecl MakeBeep(DWORD dwFreq, DWORD dwDuration)
{
    _tprintf(_T("[%d] Beep\n"), GetCurrentProcessId());
	return Beep(dwFreq, dwDuration);
}

}


